<?php
/*
Plugin Name: Ecomotriz buscador de gasolineras
Plugin URI: http://www.ecomotriz.com
Description: Buscador de gasolineras y puntos de recarga eléctrica
Version: 0.9.1
Author: Ecomotriz
Author URI: http://www.ecomotriz.com
License: GPL2
*/
?>
<?php
/*  Copyright 2012  HÉCTOR LINARES  (email : linares@ecomotriz.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>
<?php
    // Main class 
    if (!class_exists("EcomotrizBuscador")) 
    {        
        class EcomotrizBuscador 
        {
            // Width, height and checked/unchecked value of the electro-only-searcher mode :D
            private static $w = null;
            private static $h = null;
            private static $c = null;
            
            // Constructor
            function EcomotrizBuscador() 
            {
                // Create option values
                add_option("ecomotriz_widget_width", "95%");                
                add_option("ecomotriz_widget_height", "360px");
                add_option("ecomotriz_widget_check_eco", "0");
            }
            
            // Sidebar registerer
            function sidebar_widget_register() 
            {
               if (!function_exists('register_sidebar_widget')) {		        
                     return;
               }

               register_sidebar_widget(__('Ecomotriz buscador de gasolineras', 'ecomotriz-buscador-de-gasolineras'),array(&$this, 'sidebar_widget_content_gen'));
            }
            
            
            // Main function
            function sidebar_widget_content_gen($args) 
            {    
                 $title = __('Ecomotriz buscador de gasolineras', 'ecomotriz-buscador-de-gasolineras');
                 $widget_content = __('Buscador de gasolineras y puntos de recarga eléctrica', 'ecomotriz-buscador-de-gasolineras');
                 
                 $w = get_option('ecomotriz_widget_width');
                 /*
                 // Lets check the settings saved
                 if(is_numeric($w))
                 {
                     // If numeric, check for a valid number and add 'px' termination
                    if($w < 0 || $w > 1024)
                        $w = "100%";
                    else
                        $w = $w . "px";
                 }
                 else
                 {
                    // Maybe 'px' or '%' termination included, lets see
                    $len = strlen($w);
                    if(substr($w, $len-2, 1) == '%')
                    {
                        $w2 = substr($w, 0, $len - 1);
                        if (!is_numeric($w2)) $w = "100%";
                        else
                            if($w2 > 100 || $w2 < 0) $w = "100%";
                    }
                    else
                    if(substr($w, $len-3, 2) == 'px')
                    {
                        $w2 = substr($w, 0, $len - 2);
                        if (!is_numeric($w2)) $w = "100%";
                        else
                            if($w2 > 1024) $w = "100%";
                    }       
                    
                 }
                   */     
                 // Set the option for PRE
                 global $eco_only_PRE;
                 if(get_option('ecomotriz_widget_check_eco') == "1")
                    $eco_only_PRE = true;
                 else
                    $eco_only_PRE = false;                 
                 
                 extract($args);
                 echo $before_widget;
                 
                 
                 // The widget runs mainly in a external server, via iframe
                 if($eco_only_PRE)
                 {
                    echo $before_title;?>Buscar electrolineras<?php echo $after_title;
                    echo('<iframe src="http://www.ecomotriz.com/embed/search_wp.php?PRE=true" style="width: '.$w.'; height: '.get_option('ecomotriz_widget_height').'; border: none" ></iframe>');
                 }
                 else
                 {
                    echo $before_title;?>Buscador gasolineras<?php echo $after_title;
                    echo('<iframe src="http://www.ecomotriz.com/embed/search_wp.php" style="width: '.$w.'; height: '.get_option('ecomotriz_widget_height').'; border: none" ></iframe>');
                 }
                
                 // Next print logo and link to developer
                 ?>    
                    <div style="float: right; text-align: right; vertical-align: middle; margin-right: 20px;">
                        Tecnología de <a href="http://www.ecomotriz.com" target="_blank"><img src="http://www.ecomotriz.com/embed/eco_logo.png" style="height: 20px;  margin: 0px 0 -5px 0;"/></a><br/>
                    </div>
                <?php
                echo $after_widget;
            }
            
            // Admin opts, hooked 
            function admin_options()            
            {                
                add_options_page("Buscador de gasolineras y electrolineras by Ecomotriz - Opciones", "Ecomotriz", "manage_options", "ecomotriz_plugin_admin_id", array(&$this, 'admin_options_HTML'));
            }
            
            // Show the HTML of Admin Opts
            function admin_options_HTML()
            {
                // Update the checkbox value
                update_option($ecomotriz_widget_check_eco, true);
                ?>  
                    <div class="wrap">
                    <div id="icon-tools" class="icon32"><br></div><h2>Ecomotriz buscador de gasolineras y puntos de recarga eléctrica - Opciones</h2>
                    <div style="clear: both"></div>
                    <form method="post" action="options.php">
                        <?php settings_fields( 'ecomotriz_sidebar_widget_opts' ); ?>
                        
                        <label for="ecomotriz_widget_width">Ancho del widget (width):</label>
                        <input type="text" name="ecomotriz_widget_width" id="ecomotriz_widget_width" size="5" value="<?php echo get_option('ecomotriz_widget_width'); ?>" /><br/>
                        <label for="ecomotriz_widget_height">Alto del widget (height):</label>
                        <input type="text" name="ecomotriz_widget_height" id="ecomotriz_widget_height" size="5" value="<?php echo get_option('ecomotriz_widget_height'); ?>" />
                        <br/>
                        <br/>
                        <input type="checkbox" value="1" name="ecomotriz_widget_check_eco" id="ecomotriz_widget_check_eco" /><label for="ecomotriz_widget_check_eco">Activar sólo la búsqueda de puntos de recarga eléctrica</label>
                        <?php 
                        //echo("OPT: " . get_option('ecomotriz_widget_check_eco'));
                        if(get_option('ecomotriz_widget_check_eco') == "1")
                        {
                        ?>
                        <script type="text/javascript">                        
                            document.getElementById("ecomotriz_widget_check_eco").checked = true;
                        </script>
                        <?php
                        }
                        ?>
                        <br/>
                        <br/>
                        <p class="submit"><input type="submit" class="button-primary" value="<?php _e('Save Changes', 'ecomotriz-buscador-de-gasolineras') ?>" /></p>
                    </form>
                    </div>
                <?php
            }
            
            // Register widget settings in DB
            function register_settings()
            {
                register_setting( 'ecomotriz_sidebar_widget_opts', 'ecomotriz_widget_width' );
                register_setting( 'ecomotriz_sidebar_widget_opts', 'ecomotriz_widget_height' );
                register_setting( 'ecomotriz_sidebar_widget_opts', 'ecomotriz_widget_check_eco' );
            }
       
        }
     
    }
    
    
    // Create a new instance of the main class
    if (class_exists("EcomotrizBuscador")) 
    {
        $eco = new EcomotrizBuscador();
    }

    // Load the plugin
    if (isset($eco)) 
    {
        if ( is_admin() )
        { 
            // admin actions
            add_action('admin_menu', array(&$eco, 'admin_options'));
            add_action( 'admin_init', array(&$eco, 'register_settings'));
        } 
        else 
        {
            // Non admin
            
        } 
        $plugin_dir = basename(dirname(__FILE__));
        $lang_dir = $plugin_dir . "lang/";
        load_plugin_textdomain( 'ecomotriz-buscador-de-gasolineras', false, $plugin_dir );

        add_action('plugins_loaded', array(&$eco, 'sidebar_widget_register'));     
        
    }

?>
